// go.cpp : Defines the entry point for the console application.
//
#include <stdio.h>

#define NMAX 1000

int viz[NMAX][NMAX];
int n, m;
int a[NMAX][NMAX];

int value[NMAX][NMAX];


int grupSize;
int pozX, pozY;




void visit(int x, int y)
{
	if (x < 0 || x >= n || y < 0 || y >= m)
	{
		return;
	}

	if (viz[x][y] == 1)
	{
		return;
	}

	if (a[x][y] == 1)
	{
		return;
	}

	if (a[x][y] == 0)
	{
		if (pozX == -1)
		{
			pozX = x;
			pozY = y;
			return;
		}

		if (pozX == -2)
		{
			return;
		}

		if (pozX != x || pozY != y)
		{
			pozX = -2;
		}

		return;
	}

	viz[x][y] = 1;
	grupSize++;

	visit(x - 1, y);
	visit(x + 1, y);
	visit(x, y - 1);
	visit(x, y + 1);
}


int main()
{
	FILE *fin = fopen("go.in", "r");
	FILE *fout = fopen("go.out", "w");

	fscanf(fin, "%d", &n);
	fscanf(fin, "%d", &m);

	int i, j;

	for (i = 0; i < n; i++)
	{
		for (j = 0; j < m; j++)
		{
			fscanf(fin, "%d", &a[i][j]);
		}
	}

	for (i = 0; i < n; i++)
	{
		for (j = 0; j < m; j++)
		{
			if (a[i][j] == 2 && viz[i][j] == 0)
			{
				grupSize = 0;

				pozX = -1;
				pozY = -1;

				visit(i, j);

				if (pozX != -2)
				{
					value[pozX][pozY] += grupSize;
				}
			}
		}
	}

	int max = -1;
	int maxX = 0, maxY = 0;

	for (i = 0; i < n; i++)
	{
		for (j = 0; j < m; j++)
		{
			if (value[i][j] > max && a[i][j] == 0)
			{
				max = value[i][j];
				maxX = i;
				maxY = j;
			}
		}
	}

	fprintf(fout, "%d %d", maxX, maxY);
	
	fclose(fin);
	fclose(fout);

	return 0;
}

