#define TuTTy "Cosmin-Mihai Tutunaru"
#include<cstdio>
#include<algorithm>
#define infile "go.in"
#define outfile "go.out"
#define nMax 1013
#define pp pair <pair <int, int>, pair <int, int> >

using namespace std;

const int ii[] = {-1, 0, 1, 0};
const int jj[] = {0, 1, 0, -1};

pair <int, int> w[nMax * nMax];
int dp[nMax][nMax];
char h[nMax][nMax];
bool vz[nMax][nMax];
int n, m;
int lMin, cMin;

pp fill(int x, int y) {
  int first, second;
  vz[x][y] = true;
  w[first = second = 1] = make_pair(x, y);
  pp inf; inf.first.first = inf.first.second = inf.second.second = 0, inf.second.first = 0;

  while(first <= second) {
    x = w[first].first;
    y = w[first].second;
    inf.second.first++;

    for(int t = 0; t < 4; ++t) {
      int i = ii[t] + x;
      int j = jj[t] + y;
      if(i > 0 && i <= n && j > 0 && j <= m) {
        if(h[i][j] == 2 && !vz[i][j]) {
          vz[i][j] = true;
          w[++second] = make_pair(i, j);
        }
        else if(h[i][j] == 0 && (inf.first.first != i || inf.first.second != j))
          inf.first.first = i, inf.first.second = j, inf.second.second++;
      }
    }

    first++;
  }
  return inf;
}

void read() {
  scanf("%d %d\n", &n, &m);
  for(int i = 1; i <= n; ++i)
    for(int j = 1; j <= m; ++j)
      scanf("%d", &h[i][j]);
}

void solve() {
  for(int i = 1; i <= n; ++i)
    for(int j = 1; j <= m; ++j)
      if(!vz[i][j] && h[i][j] == 2) {
        pp x = fill(i, j);
        if(x.second.second == 1)
          dp[x.first.first][x.first.second] += x.second.first;
      }

  for(int i = 1; i <= n; ++i)
    for(int j = 1; j <= m; ++j) {
      if(dp[i][j] > dp[lMin][cMin] || (!lMin && !cMin && h[i][j] == 0))
        lMin = i, cMin = j;
    }
}

void write() {
  printf("%d %d\n", lMin - 1, cMin - 1);
}

int main() {
  freopen(infile, "r", stdin);
  freopen(outfile, "w", stdout);

  read();
  solve();
  write();

  fclose(stdin);
  fclose(stdout);
}

